﻿################################################################################
########################## Pipeline 1 ##########################################
################################################################################
################################################################################
################################################################################

<#
The pipeline is the key to PS.  Everything happens in the pipeline.  The pipeline is kind of a memory structure really.
Think of it like a baton in a relay race.  The 1st runner passes the baton to the next runner who in turn runs it to the next one.
This is how the pipeline works.  One command passes its output to the next command as input, and that command then does something
to the object, and then passes it along to the next command as input.  This could theoretically go on forever.

It's very important to understand that when objects are in the pipeline, they are the objects themselves, not text
representations of the objects.  This is one of the things that makes PS so powerful.  You don't have to do anything special
to access the object like you do in other languages.  You simply pick up the object and start working with it.

And because of the nature of PS and the pipeline, it's very dangerous because you're automatically working with all of the objects.
You have to explicitely filter out the objects you don't want.
At this point you've already seen the pipeline many times.
#>

##Let's start with something we've already seen.
dir | gm

##gm is short for get-member.  get-member is a command, but so is dir.
##dir outputs data.  It then gets pipelined as input to gm.  gm then gets the members
##and outputs them to the screen... by default.  You could take the output from gm
##and pipe it to another command, like a filter perhaps.

##When you get a list from gm, you'll see properties and methods.
##Properties are adjectives... they describe aspects of the object.
##Methods are verbs... they're things you can do to the object.

##gm properties also have get/set.  Not all properties have both.s













