﻿
<#
Let's sophisticate yet again.  The unattractive part of this script is that we can introduce issues because we're changing the script.
You want to change the script as little as possible, and if you can get away with it, you want to change it never if you can.

So we're going to introduce pass-in params.
#>
param ([string]$FilePath,
	[string]$FileName)


################################################################################
########################## Scripting 6 #########################################
################################################################################
################################################################################
################################################################################


If (Test-Path $FilePath\$FileName)
	{
	del $FilePath\$FileName;
	}
ELSE
	{
		"The file was not found.";
	}

##We could have put the \ in the $FilePath var itself but I prefer to see the slashes in the call.  It makes more sense to me.
##Here's what that would've looked like:

<#
$FilePath = "c:\ScriptingClass\"; 
$FileName = "MinionWare.txt";

If (Test-Path $FilePath$FileName)
{
	del $FilePath$FileName;
}
ELSE
{
	"The file was not found.";
}
#>











