﻿################################################################################
########################## Object-Oriented Programming 1 #######################
################################################################################
################################################################################
################################################################################

<#
Object-oriented programming has been the defacto standard for decades now and
is the basis for many languages including C#, VB.net and the like.
The concept is really simple even though programmers try to make it sound really
complicated.

The world is full of objects.  Every object in the world has some kind of properties.
For example, let's talk about some of the properties cars have.
Cars have 4 wheels, windshields, doors, color, weight, length, width, body type,
engine, etc.  and every single one of those things also has properties.

This is what we mean by OO programming.  Everything we touch is an object with
properties.
#>

##Let's take a look at files real quick.
dir ##run this code.

##In the file list above, each file has properties.  
##What are some properties that files can have?

##They can have a name, location, size, extension

###But we don't only have files, we also have folders.
###Do folders have the same properties as files?
###How can you tell?  This is where get-member comes in.
###GM is where you'll LIVE because you'll always be looking up members for the
###different objects.

###What are members?  Members are the properties and methods that belong to any given
###object.  We haven't talked about methods yet.  Methods are verbs... things you can
###do against an object.

#1. Let's start by looking at simple strings.  You've already seen this.
$a = "Sean"
$a | gm

$int = 5
$int | gm












