﻿################################################################################
########################## Profiles 1 ##########################################
################################################################################
################################################################################
################################################################################

<#
Profiles can be important to interactive work.  Frankly, I'm not fond of them for
scripts.  I don't like that you have to remember to move the profile around with the
scripts, and if someone changes the user acct that runs it, you could be in trouble 
there too.  

I handle common script tasks a different way that we'll discuss later today.

4 diff. levels of profiles.
i.	All users, all shells… system32\windowspowershell\v1\Profile.ps1
ii.	All users, MS shell only….system32\windowspowershell\v1\Microsoft.Powershell_profile.ps1
iii.	Current user, all shells… myDocs\WindowsPowershell\Profile.ps1
iv.	Current user, MS shell only… myDocs\WindowsPowershell\ Microsoft.Powershell_profile.ps1


#>

##Easiest way to create a profile:
New-Item -Path $profile -ItemType File -Force
notepad $profile

#Profiles aren't created by default.
#They can step on each other so if you have the same things defined at 
#different levels you'll get errors as the later elements try to load.

#When you add to your profile you can reload 2 ways:
#The problem is that if you shutdown the window you'll lose all your cmd history.
.$Profile # dot sourcing
&$Profile #invoke operator








