﻿

$ServerName = "localhost";
$DBName = "AdvancedScripting";

function QuerySQL
{
	param (
		[string]$dataSource,
		[string]$database,
		[string]$Query
	)

		$DBConnString = "Data Source=$ServerName;Initial Catalog=$DBName;Integrated Security=True;"
	
	$connection = new-object system.data.SqlClient.SQLConnection($DBConnString)
	$command = new-object system.data.sqlclient.sqlcommand($Query, $connection)
	$connection.Open()
	
	$adapter = New-Object System.Data.sqlclient.sqlDataAdapter $command
	$dataset = New-Object System.Data.DataSet
	$adapter.Fill($dataSet) | Out-Null
	
	$connection.Close()
	$dataSet.Tables
	
}


function ErrorHandler($err)
{
	If ($err)
	{
		[string]$ErrMsg = $err.exception;
		$ErrMsg = $ErrMsg.replace("`'", "`'`'")
		$Query = "INSERT dbo.ScriptErrors(ExecutionDateTime, Script, Error) SELECT '$LogDate', '$ScriptName', '$errMsg;'"
		##$Query
		QuerySQL $ServerName $DBName $Query;
	}
}